<html><head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <title>nlinregr</title>
    <style type="text/css" media="all">
      @import url("scilab_code.css");
      @import url("xml_code.css");
      @import url("c_code.css");
      @import url("style.css");
    </style>
  </head>
  <body>
    <div class="manualnavbar">
    <table width="100%"><tr>
      <td width="30%">
    	<span class="previous"><a href="nlinlsq.html">&lt;&lt; nlinlsq</a></span>

      </td>
      <td width="40%" class="center">
      	<span class="top"><a href="section_f29eb84a4bb31f3135768cacf4cf6c59.html">Regression tools (regtools)</a></span>

      </td>
      <td width="30%" class="next">
      	<span class="next"><a href="qqplot.html">qqplot &gt;&gt;</a></span>

      </td>
    </tr></table>
      <hr />
    </div>



    <span class="path"><a href="index.html">Regression tools (regtools)</a> &gt;&gt; <a href="section_f29eb84a4bb31f3135768cacf4cf6c59.html">Regression tools (regtools)</a> &gt; nlinregr</span>

    <br /><br />
    <div class="info"></div>

  <div class="refnamediv"><h1 class="refname">nlinregr</h1><p class="refpurpose">Interactive non linear regression solver</p></div>



<div class="refsynopsisdiv"><h3 class="title">Calling Sequence</h3>
   <div class="synopsis"><pre><span class="functionid">nlinregr</span><span class="default">(</span><span class="default">Data</span><span class="default">,</span><span class="default">Names</span><span class="default">,</span><span class="default">funDef</span><span class="default">,</span><span class="default">dfunDef</span><span class="default">,</span><span class="default">pDef</span><span class="default">,</span><span class="default">YDef</span><span class="default">[,</span><span class="default">WDef</span><span class="default">][,</span><span class="default">pEst</span><span class="default">][,</span><span class="default">pLo</span><span class="default">][,</span><span class="default">pUp</span><span class="default">][,</span><span class="default">alfa</span><span class="default">]) </span><span class="comment">// Start in interactive mode.</span>
<span class="default">[</span><span class="default">phat</span><span class="default">,</span><span class="default">yhat</span><span class="default">[,</span><span class="default">stat</span><span class="default">]]=</span><span class="functionid">nlinregr</span><span class="default">(</span><span class="default">Data</span><span class="default">,</span><span class="default">Names</span><span class="default">,</span><span class="default">funDef</span><span class="default">,</span><span class="default">dfunDef</span><span class="default">,</span><span class="default">pDef</span><span class="default">,</span><span class="default">YDef</span><span class="default">[,</span><span class="default">WDef</span><span class="default">][,</span><span class="default">pEst</span><span class="default">][,</span><span class="default">pLo</span><span class="default">][,</span><span class="default">pUp</span><span class="default">][,</span><span class="default">alfa</span><span class="default">]); </span><span class="comment">// Run in silent command line mode.</span>
<span class="functionid">nlinregr</span><span class="default">();  </span><span class="comment">// Start nlinregr with example data in interactive mode.</span></pre></div></div>

<div class="refsection"><h3 class="title">Parameters</h3>
   <dl><dt><span class="term">Data:</span>
      <dd><p class="para">matrix with experimental data (dependent and independent variables) stored as column vectors.</p></dd></dt>
   <dt><span class="term">Names:</span>
      <dd><p class="para">string with space separated names for each column vector in Data. E.g &#0039;x y z&#0039;.</p></dd></dt>
   <dt><span class="term">funDef:</span>
      <dd><p class="para">string with definition of the non linear regression function yhat=f(x,p). E.g &#0039;A+B*exp(C*x)&#0039;.</p></dd></dt>
   <dt><span class="term">dfunDef:</span>
      <dd><p class="para">optional string with definition analytical derivatives df(x,p)/dp. e.g &#0039;[ones(x),exp(C*x),B*x.*exp(C*x)]&#0039;.</p></dd></dt>
   <dt><span class="term">pDef:</span>
      <dd><p class="para">string with space separated parameter names. E.g. &#0039;A B C&#0039;</p></dd></dt>
   <dt><span class="term">YDef:</span>
      <dd><p class="para">string with name of the dependent data variables y (from Names)&#0039; E.g &#0039;y&#0039;</p></dd></dt>
   <dt><span class="term">WDef:</span>
      <dd><p class="para">optional flag selecting predefined weight strategy: =1(default): no weight factor wt=ones(y). =2: wt=(1)./y.^2. =3: wt=(1)./y.</p></dd></dt>
   <dt><span class="term">pEst:</span>
      <dd><p class="para">optional column vector with initial estimate for non linear regression parameters. Default is ones(np,1). pEst is also used for internal scaling of the model parameters.</p></dd></dt>
   <dt><span class="term">pLo:</span>
      <dd><p class="para">optional lower bounds on parameters as column vector or scalar (default = +%Inf).</p></dd></dt>
   <dt><span class="term">pUp:</span>
      <dd><p class="para">optional upper bounds on parameters as column vector or scalar (default = -%Inf).</p></dd></dt>
   <dt><span class="term">alfa:</span>
      <dd><p class="para">optional significance level for parameter confidence interval estimates (default alfa=0.05).</p></dd></dt>
   <dt><span class="term">phat:</span>
      <dd><p class="para">parameter value at the solution of the non linear regression problem.</p></dd></dt>
   <dt><span class="term">yhat:</span>
      <dd><p class="para">dependent variable estimates (yhat=f(x,phat)).</p></dd></dt>
   <dt><span class="term">stat:</span>
      <dd><p class="para">optional structure with regression statistics at the solution.</p></dd></dt>
   <dt><span class="term">stat.ss :</span>
      <dd><p class="para">weighted residual sum of squares ( ss = (wt.*res)&#0039;*(wt.*res) )</p></dd></dt>
   <dt><span class="term">stat.df :</span>
      <dd><p class="para">degrees of freedom ( df = length(y) - length(p) )</p></dd></dt>
   <dt><span class="term">stat.res :</span>
      <dd><p class="para">vector with residuals ( res = y-f(x,p) )</p></dd></dt>
   <dt><span class="term">stat.p :</span>
      <dd><p class="para">vector with solution of the WLSQ problem ( Minimize: ss. Subject to: plo .le. p .le. pup.)</p></dd></dt>
   <dt><span class="term">stat.pint :</span>
      <dd><p class="para">confidence interval (at alfa significance level) for reqression parameters ( pint = devp*cdft(&#0039;T&#0039;,df,1-alfa/2,alfa/2) )</p></dd></dt>
   <dt><span class="term">stat.covp :</span>
      <dd><p class="para">parameter covariance matrix ( covp = inv(df/ss*(J&#0039;*J)) where J is the Jacobi matrix of res wrt p at the solution p=phat)</p></dd></dt>
   <dt><span class="term">stat.corp :</span>
      <dd><p class="para">parameter correlation matrix ( corp = covp./sqrt(devp2*devp2&#0039;); where devp2=devp.^2; )</p></dd></dt>
   <dt><span class="term">stat.devp :</span>
      <dd><p class="para">standard error ( devp = sqrt(diag(covp)) ).</p></dd></dt></dl></div>

<div class="refsection"><h3 class="title">Description</h3>
   <p class="para">nlinregr is an interactive frontend for the non linear regression solver nlinlsq.</p>
   <p class="para">A non linear function yhat=f(x,p) is fitted to the data set y [x] using
non linear regression analysis. The following optimization problem is solved:</p>
   <p class="para">Minimize ss=sum(((y-f(x,p)).*wt).^2) subject to: pLo .le.  p .le.  pUp.</p>
   <p class="para">Regression statistics like asymptotic confidence intervals and correlation matrix
for the model parameters are calculated and presented in a solution report inspired by
the nls function in R Project.</p>
   <p class="para">Note that new data may be loaded directly from Excel spreadsheet files when nlinregr is
started in interactive mode.
Use the button &#0034;Load data&#0034; from the GUI to read data from .xls files.
The data in the Excel spreadsheets must be located in the upper left corner of the spreadsheet.
The first row should contain Names for each column vector in Data.
Numbers in subsequent rows are stored in Data. Number of columns must match number of columns
in the first row.</p>
   <p class="para">See the Scilab Demonstrations section for some non linear regression test problems from
the NIST StRG Dataset Archives. nlinregr is not able to solve all these problems.
Consider using R for hard problems.</p>
   <p class="para"></p></div>

<div class="refsection"><h3 class="title">Examples</h3>
   <div class="programlisting"><table border="0" width="100%"><tr><td width="98%"><pre class="scilabcode"><span class="scilabid">x</span><span class="scilaboperator">=</span><span class="scilaboperator">-</span><span class="scilabopenclose">[</span><span class="scilabnumber">1</span><span class="scilabspecial">:</span><span class="scilabnumber">100</span><span class="scilabopenclose">]</span><span class="scilaboperator">&#0039;</span><span class="scilaboperator">/</span><span class="scilabnumber">10</span><span class="scilabdefault">;</span> <span class="scilabid">y</span><span class="scilaboperator">=</span><span class="scilabnumber">2</span><span class="scilaboperator">+</span><span class="scilabnumber">10</span><span class="scilaboperator">*</span><a class="scilabcommand" href="scilab://exp">exp</a><span class="scilabopenclose">(</span><span class="scilabid">x</span><span class="scilaboperator">/</span><span class="scilabnumber">2</span><span class="scilabopenclose">)</span><span class="scilaboperator">+</span><a class="scilabcommand" href="scilab://grand">grand</a><span class="scilabopenclose">(</span><span class="scilabnumber">100</span><span class="scilabdefault">,</span><span class="scilabnumber">1</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">nor</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabnumber">0</span><span class="scilabdefault">,</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilaboperator">/</span><span class="scilabnumber">2</span><span class="scilabdefault">;</span> <span class="scilabcomment">// some noisy data</span>
<span class="scilabid">fun</span><span class="scilaboperator">=</span><span class="scilabstring">&#0039;</span><span class="scilabstring">A+B*exp(C*x)</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">;</span> <span class="scilabid">dfun</span><span class="scilaboperator">=</span><span class="scilabstring">&#0039;</span><span class="scilabstring">[ones(x), exp(C*x), B*x.*exp(C*x)]</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">;</span>
<span class="scilabopenclose">[</span><span class="scilabid">p</span><span class="scilabdefault">,</span><span class="scilabid">yhat</span><span class="scilabdefault">,</span><span class="scilabid">stat</span><span class="scilabopenclose">]</span><span class="scilaboperator">=</span><span class="scilabid">nlinregr</span><span class="scilabopenclose">(</span><span class="scilabopenclose">[</span><span class="scilabid">x</span> <span class="scilabid">y</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">x y</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabid">fun</span><span class="scilabdefault">,</span><span class="scilabid">dfun</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">A B C</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">y</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabnumber">1</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabnumber">1</span><span class="scilabdefault">;</span><span class="scilabnumber">1</span><span class="scilabdefault">;</span><span class="scilabnumber">1</span><span class="scilabopenclose">]</span><span class="scilabopenclose">)</span> <span class="scilabcomment">// fit curve directly</span>

<span class="scilabid">nlinregr</span><span class="scilabopenclose">(</span><span class="scilabopenclose">[</span><span class="scilabid">x</span> <span class="scilabid">y</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">x y</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabid">fun</span><span class="scilabdefault">,</span><span class="scilabid">dfun</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">A B C</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">y</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabnumber">1</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabnumber">1</span><span class="scilabdefault">;</span><span class="scilabnumber">1</span><span class="scilabdefault">;</span><span class="scilabnumber">1</span><span class="scilabopenclose">]</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span> <span class="scilabcomment">// solve problem interactivly from gui</span>

<span class="scilabcomment">// Data example from R (http://www.r-project.org/). See help on nls and DNase in R.</span>
<span class="scilabid">conc</span><span class="scilaboperator">=</span><span class="scilabopenclose">[</span><span class="scilabnumber">0.04882812</span> <span class="scilabnumber">0.04882812</span> <span class="scilabnumber">0.1953125</span> <span class="scilabnumber">0.1953125</span> <span class="scilabnumber">0.390625</span> <span class="scilabnumber">0.390625</span> <span class="scilabnumber">0.78125</span> <span class="scilabnumber">0.78125</span> <span class="scilabnumber">1.5625</span> <span class="scilabnumber">1.5625</span> <span class="scilabnumber">3.125</span> <span class="scilabnumber">3.125</span> <span class="scilabnumber">6.25</span> <span class="scilabnumber">6.25</span> <span class="scilabnumber">12.5</span> <span class="scilabnumber">12.5</span><span class="scilabopenclose">]</span><span class="scilaboperator">&#0039;</span><span class="scilabdefault">;</span>
<span class="scilabid">density</span><span class="scilaboperator">=</span><span class="scilabopenclose">[</span><span class="scilabnumber">0.017</span> <span class="scilabnumber">0.018</span> <span class="scilabnumber">0.121</span> <span class="scilabnumber">0.124</span> <span class="scilabnumber">0.206</span> <span class="scilabnumber">0.215</span> <span class="scilabnumber">0.377</span> <span class="scilabnumber">0.374</span> <span class="scilabnumber">0.614</span> <span class="scilabnumber">0.609</span> <span class="scilabnumber">1.019</span> <span class="scilabnumber">1.001</span> <span class="scilabnumber">1.334</span> <span class="scilabnumber">1.364</span> <span class="scilabnumber">1.73</span> <span class="scilabnumber">1.71</span><span class="scilabopenclose">]</span><span class="scilaboperator">&#0039;</span><span class="scilabdefault">;</span>
<span class="scilabid">fun</span><span class="scilaboperator">=</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Asym./(1+exp((xmid-log(conc))./scal))</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">;</span> <span class="scilabid">pnames</span><span class="scilaboperator">=</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Asym xmid scal</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">;</span>
<span class="scilabid">dfun</span><span class="scilaboperator">=</span><span class="scilabstring">&#0039;</span><span class="scilabstring">[1.0./(exp((xmid-log(conc))/scal)+1), Asym*exp((xmid-log(conc))/scal)./(scal*(exp((xmid-log(conc))/scal)+1).^2), Asym*(xmid-log(conc)).*exp((xmid-log(conc))/scal)./(scal^2*(exp((xmid-log(conc))/scal)+1).^2)]</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">;</span>
<span class="scilabopenclose">[</span><span class="scilabid">p</span><span class="scilabdefault">,</span><span class="scilabid">yhat</span><span class="scilabdefault">,</span><span class="scilabid">stat</span><span class="scilabopenclose">]</span><span class="scilaboperator">=</span><span class="scilabid">nlinregr</span><span class="scilabopenclose">(</span><span class="scilabopenclose">[</span><span class="scilabid">conc</span> <span class="scilabid">density</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">conc density</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabid">fun</span><span class="scilabdefault">,</span><span class="scilabid">dfun</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Asym xmid scal</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">density</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabnumber">1</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabnumber">1</span><span class="scilabdefault">;</span><span class="scilabnumber">1</span><span class="scilabdefault">;</span><span class="scilabnumber">1</span><span class="scilabopenclose">]</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span> <span class="scilabcomment">// unweighted model</span>

<span class="scilabid">nlinregr</span><span class="scilabopenclose">(</span><span class="scilabopenclose">[</span><span class="scilabid">conc</span> <span class="scilabid">density</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">conc density</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabid">fun</span><span class="scilabdefault">,</span><span class="scilabid">dfun</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">Asym xmid scal</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabstring">&#0039;</span><span class="scilabstring">density</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span><span class="scilabnumber">2</span><span class="scilabdefault">,</span><span class="scilabopenclose">[</span><span class="scilabnumber">1</span><span class="scilabdefault">;</span><span class="scilabnumber">1</span><span class="scilabdefault">;</span><span class="scilabnumber">1</span><span class="scilabopenclose">]</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span> <span class="scilabcomment">// weighted model</span></pre></td><td valign="top"><a href="scilab://scilab.execexample/"><img src="ScilabExecute.png" border="0"/></a></td><td valign="top"><a href="scilab://scilab.editexample/"><img src="ScilabEdit.png" border="0"/></a></td><td></td></tr></table></div></div>

<div class="refsection"><h3 class="title">See also</h3>
   <ul class="itemizedlist"><li class="member"><a href="nlinlsq.html" class="link">nlinlsq</a></li>
   <li class="member"><a href="linregr.html" class="link">linregr</a></li></ul></div>

<div class="refsection"><h3 class="title">Authors</h3>
   <ul class="itemizedlist"><li class="member">T. Pettersen, top@tpett.com</li></ul></div>

<div class="refsection"><h3 class="title">Bibliography</h3>
   <p class="para">The R Project (www.r-project.org)</p>
   <p class="para">NIST StRD Dataset Archives - Non linear regression http://www.itl.nist.gov/div898/strd/general/dataarchive.html</p></div>


    <div class="manualnavbar">
    <table width="100%"><tr>
      <td width="30%">
    	<span class="previous"><a href="nlinlsq.html">&lt;&lt; nlinlsq</a></span>

      </td>
      <td width="40%" class="center">
      	<span class="top"><a href="section_f29eb84a4bb31f3135768cacf4cf6c59.html">Regression tools (regtools)</a></span>

      </td>
      <td width="30%" class="next">
      	<span class="next"><a href="qqplot.html">qqplot &gt;&gt;</a></span>

      </td>
    </tr></table>
      <hr />
    </div>
  </body>
</html>
